"""Constants for sudokulib"""

GRID_WIDTH = 9

BLOCK_WIDTH = 3

GRID_TOTAL = GRID_WIDTH * GRID_WIDTH

INDEX_REGIONS = {0: {'col': 0, 'row': 0,  'block': 0},
                 1: {'col': 1, 'row': 0,  'block': 0},
                 2: {'col': 2, 'row': 0,  'block': 0},
                 3: {'col': 3, 'row': 0,  'block': 1},
                 4: {'col': 4, 'row': 0,  'block': 1},
                 5: {'col': 5, 'row': 0,  'block': 1},
                 6: {'col': 6, 'row': 0,  'block': 2},
                 7: {'col': 7, 'row': 0,  'block': 2},
                 8: {'col': 8, 'row': 0,  'block': 2},
                 9: {'col': 0, 'row': 1,  'block': 0},
                 10: {'col': 1, 'row': 1,  'block': 0},
                 11: {'col': 2, 'row': 1,  'block': 0},
                 12: {'col': 3, 'row': 1,  'block': 1},
                 13: {'col': 4, 'row': 1,  'block': 1},
                 14: {'col': 5, 'row': 1,  'block': 1},
                 15: {'col': 6, 'row': 1,  'block': 2},
                 16: {'col': 7, 'row': 1,  'block': 2},
                 17: {'col': 8, 'row': 1,  'block': 2},
                 18: {'col': 0, 'row': 2,  'block': 0},
                 19: {'col': 1, 'row': 2,  'block': 0},
                 20: {'col': 2, 'row': 2,  'block': 0},
                 21: {'col': 3, 'row': 2,  'block': 1},
                 22: {'col': 4, 'row': 2,  'block': 1},
                 23: {'col': 5, 'row': 2,  'block': 1},
                 24: {'col': 6, 'row': 2,  'block': 2},
                 25: {'col': 7, 'row': 2,  'block': 2},
                 26: {'col': 8, 'row': 2,  'block': 2},
                 27: {'col': 0, 'row': 3,  'block': 3},
                 28: {'col': 1, 'row': 3,  'block': 3},
                 29: {'col': 2, 'row': 3,  'block': 3},
                 30: {'col': 3, 'row': 3,  'block': 4},
                 31: {'col': 4, 'row': 3,  'block': 4},
                 32: {'col': 5, 'row': 3,  'block': 4},
                 33: {'col': 6, 'row': 3,  'block': 5},
                 34: {'col': 7, 'row': 3,  'block': 5},
                 35: {'col': 8, 'row': 3,  'block': 5},
                 36: {'col': 0, 'row': 4,  'block': 3},
                 37: {'col': 1, 'row': 4,  'block': 3},
                 38: {'col': 2, 'row': 4,  'block': 3},
                 39: {'col': 3, 'row': 4,  'block': 4},
                 40: {'col': 4, 'row': 4,  'block': 4},
                 41: {'col': 5, 'row': 4,  'block': 4},
                 42: {'col': 6, 'row': 4,  'block': 5},
                 43: {'col': 7, 'row': 4,  'block': 5},
                 44: {'col': 8, 'row': 4,  'block': 5},
                 45: {'col': 0, 'row': 5,  'block': 3},
                 46: {'col': 1, 'row': 5,  'block': 3},
                 47: {'col': 2, 'row': 5,  'block': 3},
                 48: {'col': 3, 'row': 5,  'block': 4},
                 49: {'col': 4, 'row': 5,  'block': 4},
                 50: {'col': 5, 'row': 5,  'block': 4},
                 51: {'col': 6, 'row': 5,  'block': 5},
                 52: {'col': 7, 'row': 5,  'block': 5},
                 53: {'col': 8, 'row': 5,  'block': 5},
                 54: {'col': 0, 'row': 6,  'block': 6},
                 55: {'col': 1, 'row': 6,  'block': 6},
                 56: {'col': 2, 'row': 6,  'block': 6},
                 57: {'col': 3, 'row': 6,  'block': 7},
                 58: {'col': 4, 'row': 6,  'block': 7},
                 59: {'col': 5, 'row': 6,  'block': 7},
                 60: {'col': 6, 'row': 6,  'block': 8},
                 61: {'col': 7, 'row': 6,  'block': 8},
                 62: {'col': 8, 'row': 6,  'block': 8},
                 63: {'col': 0, 'row': 7,  'block': 6},
                 64: {'col': 1, 'row': 7,  'block': 6},
                 65: {'col': 2, 'row': 7,  'block': 6},
                 66: {'col': 3, 'row': 7,  'block': 7},
                 67: {'col': 4, 'row': 7,  'block': 7},
                 68: {'col': 5, 'row': 7,  'block': 7},
                 69: {'col': 6, 'row': 7,  'block': 8},
                 70: {'col': 7, 'row': 7,  'block': 8},
                 71: {'col': 8, 'row': 7,  'block': 8},
                 72: {'col': 0, 'row': 8,  'block': 6},
                 73: {'col': 1, 'row': 8,  'block': 6},
                 74: {'col': 2, 'row': 8,  'block': 6},
                 75: {'col': 3, 'row': 8,  'block': 7},
                 76: {'col': 4, 'row': 8,  'block': 7},
                 77: {'col': 5, 'row': 8,  'block': 7},
                 78: {'col': 6, 'row': 8,  'block': 8},
                 79: {'col': 7, 'row': 8,  'block': 8},
                 80: {'col': 8, 'row': 8,  'block': 8},
                 }


REGION_INDEXES = {'col': {0: [0, 9, 18, 27, 36, 45, 54, 63, 72],
                          1: [1, 10, 19, 28, 37, 46, 55, 64, 73],
                          2: [2, 11, 20, 29, 38, 47, 56, 65, 74],
                          3: [3, 12, 21, 30, 39, 48, 57, 66, 75],
                          4: [4, 13, 22, 31, 40, 49, 58, 67, 76],
                          5: [5, 14, 23, 32, 41, 50, 59, 68, 77],
                          6: [6, 15, 24, 33, 42, 51, 60, 69, 78],
                          7: [7, 16, 25, 34, 43, 52, 61, 70, 79],
                          8: [8, 17, 26, 35, 44, 53, 62, 71, 80]},
                  'row': {0: [0, 1, 2, 3, 4, 5, 6, 7, 8],
                          1: [9, 10, 11, 12, 13, 14, 15, 16, 17],
                          2: [18, 19, 20, 21, 22, 23, 24, 25, 26],
                          3: [27, 28, 29, 30, 31, 32, 33, 34, 35],
                          4: [36, 37, 38, 39, 40, 41, 42, 43, 44],
                          5: [45, 46, 47, 48, 49, 50, 51, 52, 53],
                          6: [54, 55, 56, 57, 58, 59, 60, 61, 62],
                          7: [63, 64, 65, 66, 67, 68, 69, 70, 71],
                          8: [72, 73, 74, 75, 76, 77, 78, 79, 80]},
                  'block': {0: [0, 1, 2, 9, 10, 11, 18, 19, 20],
                            1: [3, 4, 5, 12, 13, 14, 21, 22, 23],
                            2: [6, 7, 8, 15, 16, 17, 24, 25, 26],
                            3: [27, 28, 29, 36, 37, 38, 45, 46, 47],
                            4: [30, 31, 32, 39, 40, 41, 48, 49, 50],
                            5: [33, 34, 35, 42, 43, 44, 51, 52, 53],
                            6: [54, 55, 56, 63, 64, 65, 72, 73, 74],
                            7: [57, 58, 59, 66, 67, 68, 75, 76, 77],
                            8: [60, 61, 62, 69, 70, 71, 78, 79, 80]},
                  }
